## Create Shipping Rate

### cURL

```
curl --request POST \
  --url https://api.withflex.com/v1/shipping_rates \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "shipping_rate": {
    "display_name": "Example",
    "amount": 2500,
    "metadata": {
      "order_id": "8842",
      "channel": "shopify"
    }
  }
}
'  
```

### Python

```
import requests

url = "https://api.withflex.com/v1/shipping_rates"

payload = { "shipping_rate": {
        "display_name": "Example",
        "amount": 2500,
        "metadata": {
            "order_id": "8842",
            "channel": "shopify"
        }
    } }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
```

### JavaScript

```
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: JSON.stringify({
    shipping_rate: {
      display_name: 'Example',
      amount: 2500,
      metadata: {order_id: '8842', channel: 'shopify'}
    }
  })
};

fetch('https://api.withflex.com/v1/shipping_rates', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));
```

### PHP

```
<?php

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.withflex.com/v1/shipping_rates",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode([
    'shipping_rate' => [
        'display_name' => 'Example',
        'amount' => 2500,
        'metadata' => [
                'order_id' => '8842',
                'channel' => 'shopify'
        ]
    ]
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
?>
```

### Go

```
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

url := "https://api.withflex.com/v1/shipping_rates"

payload := strings.NewReader("{\n  \"shipping_rate\": {\n    \"display_name\": \"Example\",\n    \"amount\": 2500,\n    \"metadata\": {\n      \"order_id\": \"8842\",\n      \"channel\": \"shopify\"\n    }\n  }\n}")

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}
```

### Unirest (Java)

```
HttpResponse<String> response = Unirest.post("https://api.withflex.com/v1/shipping_rates")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"shipping_rate\": {\n    \"display_name\": \"Example\",\n    \"amount\": 2500,\n    \"metadata\": {\n      \"order_id\": \"8842\",\n      \"channel\": \"shopify\"\n    }\n  }\n}")
  .asString();
```

### Ruby

```
require 'uri'
require 'net/http'

url = URI("https://api.withflex.com/v1/shipping_rates")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"shipping_rate\": {\n    \"display_name\": \"Example\",\n    \"amount\": 2500,\n    \"metadata\": {\n      \"order_id\": \"8842\",\n      \"channel\": \"shopify\"\n    }\n  }\n}"

response = http.request(request)
puts response.read_body
```

### Response Codes

- `200`
- `401`
- `403`
- `404`
- `409`
- `422`
- `429`

### Sample JSON Response

```
{
  "shipping_rate": {
    "shipping_rate_id": "fshr_01J9XR8M3K7VZ8N2YB4WJ6T0RA",
    "active": false,
    "display_name": "Example",
    "amount": 2500,
    "metadata": {
      "order_id": "8842",
      "channel": "shopify"
    },
    "created_at": "2026-06-15T14:30:00Z"
  }
}
```

### Error Response

```
{
  "code": "string",
  "detail": "string"
}
```

### Authorizations

- **Authorization**: Use a Bearer token to access this API.

### Body Schema

**shipping_rate** object (required): The shipping rate.

**Example Request Body:**
```
{
  "display_name": "Example",
  "amount": 2500,
  "metadata": { "order_id": "8842", "channel": "shopify" }
}
```

### Response Schema

**shipping_rate** object (required): The shipping rate.
**Example Response Body:**
```
{
  "shipping_rate_id": "fshr_01J9XR8M3K7VZ8N2YB4WJ6T0RA",
  "active": false,
  "display_name": "Example",
  "amount": 2500,
  "metadata": { "order_id": "8842", "channel": "shopify" },
  "created_at": "2026-06-15T14:30:00Z"
}
```
